*DECK FLPREL
      SUBROUTINE FLPREL(RELAX,IPLCM,NAMP,ILONG,ARRAY)
*
*-----------------------------------------------------------------------
*
*Purpose:
* relaxation procedure for power distribution information.
*
*Copyright:
* Copyright (C) 2014 Ecole Polytechnique de Montreal.
*
*Author(s): A. Hebert
*
*Parameters: input/output
* RELAX  relaxation factor
* IPLCM  pointer to power information.
* NAMP   name of LCM record to relax
* ILONG  length of LCM record to relax
* ARRAY  real record to relax 
*
*Parameters: input/output
* ARRAY  real record after relaxation
*
*-----------------------------------------------------------------------
*
      USE GANLIB
*----
*  SUBROUTINE ARGUMENTS
*----
      TYPE(C_PTR) IPLCM
      INTEGER ILONG
      REAL RELAX,ARRAY(ILONG)
      CHARACTER NAMP*(*)
*----
*  LOCAL VARIABLES
*----
      REAL, ALLOCATABLE, DIMENSION(:) :: ARRAY0
*
      IF(RELAX.EQ.1.0) RETURN
      CALL LCMLEN(IPLCM,NAMP,ILONG0,ITYLCM)
      IF(ILONG0.NE.ILONG) CALL XABORT('@FLPREL: UNABLE TO RELAX.')
      ALLOCATE(ARRAY0(ILONG))
      CALL LCMGET(IPLCM,NAMP,ARRAY0)
      DO I=1,ILONG
        ARRAY(I)=RELAX*ARRAY(I)+(1.0-RELAX)*ARRAY0(I)
      ENDDO
      DEALLOCATE(ARRAY0)
      RETURN
      END
